//+------------------------------------------------------------------+
//|                                             Pinggarcia RSI Cross |
//|                                                                  |
//+------------------------------------------------------------------+


extern int MagicNumber = 1537;
extern string ExpertName = "Pinggarcia RSI Cross";
extern bool SignalMail = False;
extern bool EachTickMode = true;

extern int Slippage = 3;
extern bool StopLossMode = false;
extern int StopLoss = 20;  //stop loss and breakeven work well with each other
extern bool TakeProfitMode = false;
extern int TakeProfit = 10;
extern bool TrailingStopMode = false;  //having problems fixing interaction between breakeven code and trailingstop
extern int TrailingStop = 0; //please use either trailing stop or breakeven...thanks...

//-----Define Trading Hours
extern bool UseHourTrade = false;
extern int FromHourTrade = 2;
extern int ToHourTrade = 21;


//-----Break Even Move Info
extern int BreakEvenLevel = 0;   //once trade has increased in pips, the SL will be moved by BreakEvenMove
extern int BreakEvenMove = 0;  //if positive value, the SL will move to this amount but still remove below open price (for a long)
                                //to move above above open order (again for a long) input a negative value.
                                //same logic and value inputs are the same for shorts

//---- Money Management
extern double Lots = 1;
extern bool UseMoneyManagement = false; //Use Money Management or not
extern bool AccountIsMicro = false; //Use Micro-Account or not
extern double Risk = 10; //10%
extern double MaxLots = 10; //max lots if MM is used

extern int FastRSILength = 5;
extern int SlowRSILength = 14;
extern double RSIBuyEntry = 40.0;
extern double RSISellEntry = 60.0;
extern double RSIDeltaFilter = 5.0;

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;

static bool ITradedOnThisBar;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}


double LotSize()
{ 
	  	  if(AccountIsMicro==false) //normal account
	  {
	     double lotMM = NormalizeDouble((AccountFreeMargin() *  Risk / 1000) / 100,2);
	     if (lotMM < 0.01) lotMM = Lots;
	     if  (lotMM > MaxLots) lotMM = MaxLots;
	  }
	  else //micro account
	  {
	     lotMM = NormalizeDouble((AccountFreeMargin() *  Risk / 1000) / 1000,2);
	     if (lotMM < 0.01) lotMM = Lots;   
	     if  (lotMM > MaxLots) lotMM = MaxLots;
	  }
	  
	  return (lotMM);
}


int CheckExitCondition(int cmd)
{
   
double FastRSICurrent = iRSI(NULL,0,FastRSILength,0,1);
double FastRSIPrevious = iRSI(NULL,0,FastRSILength,0,2);

double SlowRSICurrent = iRSI(NULL,0,SlowRSILength,0,1);
double SlowRSIPrevious = iRSI(NULL,0,SlowRSILength,0,2);

   switch (cmd)
   {
   case OP_BUY :
                 

       if (SlowRSIPrevious >= RSISellEntry && FastRSIPrevious >= SlowRSIPrevious && FastRSICurrent < SlowRSICurrent) return(SIGNAL_CLOSEBUY);
             
       break;
       
   case OP_SELL :

        if (SlowRSIPrevious <= RSIBuyEntry && FastRSIPrevious <= SlowRSIPrevious && FastRSICurrent > SlowRSICurrent) return(SIGNAL_CLOSESELL);

   }
   return (SIGNAL_NONE);
}


int CheckEntryCondition(int cmd)
{
      
double FastRSICurrent = iRSI(NULL,0,FastRSILength,0,1);
double FastRSIPrevious = iRSI(NULL,0,FastRSILength,0,2);

double SlowRSICurrent = iRSI(NULL,0,SlowRSILength,0,1);
double SlowRSIPrevious = iRSI(NULL,0,SlowRSILength,0,2);

   switch(cmd)
   {
   case OP_BUY :
      if (SlowRSIPrevious <= RSIBuyEntry && FastRSIPrevious <= SlowRSIPrevious && FastRSICurrent > SlowRSICurrent && (FastRSICurrent - SlowRSICurrent >= RSIDeltaFilter)) return(SIGNAL_BUY);
      
      
      break;
   case OP_SELL :
      if (SlowRSIPrevious >= RSISellEntry && FastRSIPrevious >= SlowRSIPrevious && FastRSICurrent < SlowRSICurrent && (SlowRSICurrent - FastRSICurrent >= RSIDeltaFilter)) return(SIGNAL_SELL);
      
      
   }

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   return(SIGNAL_NONE);
   
}

bool HandleOpenPositions()
{

   bool myIsTrade = False;
   int Order = SIGNAL_NONE;
   int Total;

   Total = OrdersTotal();
   for (int i = Total - 1; i >=0; i--){
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol()) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      myIsTrade = True;
      if(ITradedOnThisBar != Bars){
         if(OrderType() == OP_BUY)
         {
            //Close
            if ( (EachTickMode && !TickCheck) || ( !EachTickMode && (Bars != BarCount) ) ){
              Order = CheckExitCondition(OP_BUY);
              if (Order == SIGNAL_CLOSEBUY){
                OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
                if (!EachTickMode) BarCount = Bars;
                myIsTrade = False;
                continue;
              }
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
               //Breakeven Check
            if (BreakEvenLevel > 0 && Bid-OrderOpenPrice()>BreakEvenLevel*Point) {
               OrderModify(OrderTicket(), OrderOpenPrice(),OrderOpenPrice()-BreakEvenMove*Point, OrderTakeProfit(), 0, DarkOrange);
               if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
            }
         }
         if (OrderType() == OP_SELL){
            //Close

            if ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))) {
              Order = CheckExitCondition(OP_SELL);
              if (Order == SIGNAL_CLOSESELL) {
                 OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
                 if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
                 if (!EachTickMode) BarCount = Bars;
                 myIsTrade = False;
                 continue;
              }
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
            //Breakeven Check
            if (BreakEvenLevel > 0 && OrderOpenPrice()-Ask>BreakEvenLevel*Point) {
               OrderModify(OrderTicket(), OrderOpenPrice(),OrderOpenPrice()+BreakEvenMove*Point, OrderTakeProfit(), 0, DarkOrange);
               if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
         }
      }
   }
   return (myIsTrade);

}

void OpenBuyOrder()
{

   int Ticket;
   double StopLossLevel, TakeProfitLevel;
   if(UseMoneyManagement==true) Lots = LotSize(); //Adjust the lot size      
   if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
   if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

   Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, ExpertName, MagicNumber, 0, DodgerBlue);
   ITradedOnThisBar = Bars;
   if(Ticket > 0) {
      if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				   Print("BUY order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		} else {
				   Print("Error opening BUY order : ", GetLastError());
		}
   }

}

void OpenSellOrder()
{         

   int Ticket;
   double StopLossLevel, TakeProfitLevel;
   if(UseMoneyManagement==true) Lots = LotSize(); //Adjust the lot size
   if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
   if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

   Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, ExpertName, MagicNumber, 0, DeepPink);
   ITradedOnThisBar = Bars;
   if(Ticket > 0) {
      if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				   Print("SELL order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
		} else {
				   Print("Error opening SELL order : ", GetLastError());
		}
   }

}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{
   int Order = SIGNAL_NONE;
   bool IsTrade = False;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Order = SIGNAL_NONE;

   //Check position
   IsTrade = HandleOpenPositions();
   
  if(ITradedOnThisBar != Bars){
    if(!IsTrade) {
         //Check free margin
       if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
       }
// Moved time check to here so that the modify and exit logic would run outside of trading hours

       if (UseHourTrade){
         if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
           Comment("Time for trade has not come else!");
           return(0);
         }
       }

   //Buy
       Order = CheckEntryCondition(OP_BUY);
       if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
         OpenBuyOrder();
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
       }
    }

    if(!IsTrade) {
         //Check free margin
       if (AccountFreeMargin() < (1000 * Lots)) {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);
       }

// Moved time check to here so that the modify and exit logic would run outside of trading hours

       if (UseHourTrade){
         if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
            Comment("Time for trade has not come else!");
            return(0);
         }
       }

   //Sell
       Order = CheckEntryCondition(OP_SELL);
       if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
         OpenSellOrder();
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
       }
    }
   }
   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+